Program WhoCalled;
{
       Who Called / Last Ten Callers
       -----------------------------
       Written: Jan 08 2011 by Shawn Highfield

 What is it:
                Simple program that will write the last ten callers, with
                date / time and IP (or location) address to a file, and
                optionaly display it back to you from a DOOR or a Webpage.

       Todo:


       Done:
                - CGI version
                - Make the Sysop name configurable
                - DOS port
                - Fix the "User Name" field will now make it "user.name"
                - Trim the data file
}

(*
If you are running a DOS BBS software, that (obviously) doesn't keep track
of IP addresses.  Just enable "Lux" mode here.  This will 1) compile for
DOS, and 2) display the user's Location instead of IP address.
*)

{.$DEFINE LUX}

uses
  {$IFDEF WIN32}
  StrStf,                 {You can dupe the routines I'm sure}
  XDoor,                  {Free door programming for all}
  {$ELSE}
  Door,                   {Edoor by Enigma is used for DOS}
  XfileIO,                {Part of Xdoor used here as well}
  {$ENDIF}
  Dos;

const
  days:array [0..6] of String[9] = ('Sunday','Monday','Tuesday','Wednesday',
                                    'Thursday','Friday','Saturday');
  month:array [1..12] of String[3] = ('Jan','Feb','Mar','Apr','May','Jun',
                                      'Jul','Aug','Sep','Oct','Nov','Dec');

var
  f: Text;
  UserName: String;                     {Derrr}
  UserIP: String;
  WhatAreWeDoing: String;               {Are we reading or writing?}
  {$IFDEF WIN32}
  Hour,Min,Sec,Hund,Mn: Longint;        {For Displaying the Time}
  Y,M,D,DOW     : Longint;              {Year,Month,Day,Day of Week}
  {$ELSE}
  Hour,Min,Sec,Hund,Mn: Word;
  Y,M,D,DOW     : Word;
  {$ENDIF}
  CountedLines: Integer;
  Row: Integer;
  TheDate: String;
  TheTime: String;
  L,
  Backline: Integer;
  TheSysopName: String;

{$IFDEF MSDOS}
function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

function exedir: string;
var
  s: string;
begin
  s:=paramstr(0);
  while s[length(s)]<>'\' do dec(s[0]);
  exedir:=s;
end;

Function numpad(i: longint;len: byte): String;
Var
  S: String;
Begin
  S := ItoS(i);
  if length(s) < len then While length(s) < len Do S := '0' + S;
  NumPad := S;
End;

Procedure trimFile(Fname: string;numLines: integer);
 Var lineCount: Integer;
             s: string;
            tf: text;
             i: integer;
             f: text;
 Begin
  if not fileexists(fname) then exit;
  assign(f,fname);
  if numLines = 0 then exit;

    { get # of lines }
    opentxtr(f);
    lineCount := 0;
     while not eof(f) do begin
      readln(f,s);
      inc(lineCount);
      end;
    close(f);
    { get # of lines end }
  if lineCount <= numLines then exit;
  opentxtr(f);
  for i := 1 to (linecount-numlines) do readln(f,s);
  assign(tf,'trim.'+numpad(node,3));
  rewrite(tf);
  while not eof(f) do begin
   readln(f,s);
   writeln(tf,s);
   end;
  close(f); close(tf);
  erase(f);
  rename(tf,fname);
 End;

{$ENDIF}

Procedure WriteItOut;
var
  hr: LongInt;
  Str,
  Str2: String;
begin
  Getdate(Y,M,D,DOW);                   {Gimmie the date from dos;}
  TheDate := ItoS(M) + '/' + ItoS(D) + '/' + ItoS(Y);

  GetTime(Hour,Min,Sec,Hund);           {Gimmie the time dos!}
  if Hour = 0 then Hr := 12             {Is this am or pm}
  else if Hour > 12 then Hr := Hour - 12
  else Hr := Hour;
  Str2 := LeadingZero(Hr) + ':' + LeadingZero(Min);
  if Hour >= 12 then Str2 := Str2 + ' pm' else Str2 := Str2 + ' am';

  TheTime := Str2;
  Assign(F, exedir + 'today.txt');
  {$I-}Append(F);{$I+}
  if ioresult<>0 then                                                           {Error checking on this one}
  begin
    WriteLn('Datafile ' + exedir + 'today.txt not found');
    Halt;
  end;
  WriteLn(F, UserName);
  WriteLn(F, UserIP);
  WriteLn(F, TheDate);
  WriteLn(F, TheTime);
  Close(F);
end;

procedure TnyBorderDisp;
begin
{$IFDEF WIN32}
  COutLn('');
  COutLn('|12|16|04|12|04    |08                                                |04   |12|04|12');
  COutLn('|20|16                                                                             |20');
  COutLn('|04|16                                                                             ');
  COutLn('                                                                             ');
  COutLn('                                                                             ');
  COutLn('                                                                               ');
  COutLn('                                                                               ');
  COutLn('                                                                               ');
  COutLn('                                                                               ');
  COutLn('                                                                               ');
  COutLn('|08                                                                             ');
  COutLn('                                                                             ');
  COutLn('|04                                                                             ');
  COutLn('                                                                             ');
  COutLn('                                                                             ');
  COutLn('|12|20|16                                                                             |20');
  COutLn('|16|04|12|04    |08                                                |04   |12|04|12');
{$ELSE}
  DPipeLn('');
  DPipeLn('|12|16|04|12|04    |08                                                |04   |12|04|12');
  DPipeLn('|20|16                                                                             |20');
  DPipeLn('|04|16                                                                             ');
  DPipeLn('                                                                             ');
  DPipeLn('                                                                             ');
  DPipeLn('                                                                               ');
  DPipeLn('                                                                               ');
  DPipeLn('                                                                               ');
  DPipeLn('                                                                               ');
  DPipeLn('                                                                               ');
  DPipeLn('|08                                                                             ');
  DPipeLn('                                                                             ');
  DPipeLn('|04                                                                             ');
  DPipeLn('                                                                             ');
  DPipeLn('                                                                             ');
  DPipeLn('|12|20|16                                                                             |20');
  DPipeLn('|16|04|12|04    |08                                                |04   |12|04|12');
{$ENDIF}
end;

Procedure HitEnter;
var
  ch: Char;
begin
  {$IFDEF WIN32}
  COut(Center('|15Press |04<|12ENTER|04> |15To continue.'));
  repeat
  until cKeyPressed;
  {$ELSE}
  DPipe(Center('|15Press |04<|12ENTER|04> |15To continue.'));
  repeat
  until DKeyPressed;
  {$ENDIF}
end;

Procedure ReadTheConfig;                {Fuck error checking ;) }
var
  f: Text;
  S: String;
begin
  Assign(F, exedir + 'whocall.cfg');
  Reset(F);
  ReadLn(F,S);
  ReadLn(F,S);
  ReadLn(F,S);
  ReadLn(F,S);
  ReadLn(F, TheSysopName);
  Close(F);
end;

Procedure CountTheLines;
var
  x: word;
  i: Integer;
  s: String;
  f: Text;
begin
  i:=0;
  Assign(F, exedir + 'today.txt');
{$I-}
  REset(F);
  x := ioresult;
{$I+}
  While not EOF(F) do
  begin
    ReadLn(F, S);
    ReadLn(F, S);
    ReadLn(F, S);
    ReadLn(F, s);
    Inc(I);
  end;
  Close(F);
  CountedLines := i;
end;

Procedure Last10Callers;
var
  i: Integer;
  s: String;
  Txt: array[1..100] of string[50];
begin
  i := 1;
  backline := CountedLines;
  l := backline;
  Assign(F, exedir + 'today.txt');
  Reset(F);
  While i <= (backline * 4) do
  begin
    ReadLn(F, s);
    Txt[i] := s;
    Inc(I);
  end;
  if L > 10 then L := 10;
  For backline := L downto 1 do
  begin
    {$IFDEF WIN32}
    ReadLn(F, s);
    CGotoXY(5, row);
    COut('|10' + TXT[i-4]);
    CGotoXY(35, row);
    ReadLn(F, s);
    COut('|11' + TXT[i-3]);
    CGotoXY(52, row);
    ReadLn(F, s);
    COut('|13' + TXT[i-2]);
    CGotoXY(65, row);
    ReadLn(F, s);
    COut('|09' + TXT[i-1]);
    {$ELSE}
    ReadLn(F, s);
    DGotoXY(5, row);
    DPipe('|10' + TXT[i-4]);
    DGotoXY(35, row);
    ReadLn(F, s);
    DPipe('|11' + TXT[i-3]);
    DGotoXY(52, row);
    ReadLn(F, s);
    DPipe('|13' + TXT[i-2]);
    DGotoXY(65, row);
    ReadLn(F, s);
    DPipe('|09' + TXT[i-1]);
    {$ENDIF}
    Dec(i,4);
    Inc(Row);
  end;
  Close(F);
end;

Procedure Header;
var
  pps: Boolean;
begin
  pps := False;
  {$IFDEF WIN32}
  ShowFile(exedir + 'last.ans', pps);
  {$ELSE}
  TypeFile(exedir + 'last.ans', pps);
  {$ENDIF}
end;


Procedure ReadIt;
begin
  {$IFDEF WIN32}
  doorname:='WhoCalled/Win32';
  cfgname:='whocall.cfg';           {Config File name = wall.cfg          }
  InitDoor;                         {Load/Parse the config file/drop file }
  CClrScr;
  {$ELSE}
  doorname := 'WhoCalled/Dos';
  cfgfn := 'whocall.cfg';
  loadcfg;
  DClrScr;
  {$ENDIF}
{  Setup the screen}
  Header;
  TnyBorderDisp;
  {$IFDEF WIN32}
  CGotoXY(5,6);
  Cout('|07Username');
  CGotoXY(35,6);
  COut('|07IP');
  CGotoXY(52,6);
  COut('|07Date');
  CGotoXY(65,6);
  COut('|07Time');
  CGotoXY(5,7);
  COut('|14--------------------------------------------------------------------');
{ Read The last callers }
  row := 8;
  CountTheLines;
  Last10Callers;
  CGotoXY(5,18);
  COut('|14--------------------------------------------------------------------');
  CGotoXY(1,23);
  {$ELSE}
  DGotoXY(5,6);
  DPipe('|07Username');
  DGotoXY(35,6);
  DPipe('|07Location');
  DGotoXY(52,6);
  DPipe('|07Date');
  DGotoXY(65,6);
  DPipe('|07Time');
  DGotoXY(5,7);
  DPipe('|14--------------------------------------------------------------------');
{ Read The last callers }
  row := 8;
  CountTheLines;
  Last10Callers;
  DGotoXY(5,18);
  DPipe('|14--------------------------------------------------------------------');
  DGotoXY(1,23);
  {$ENDIF}
  HitEnter;
end;

begin
  ReadTheConfig;
  TrimFile(exedir + 'today.txt', 40);   {Keeping the "datafile" to no more then 10 callers}
  WhatAreWeDoing := ParamStr(1);
  if ParamCount = 4 then                {Paramcount 4 means "user name"}
  begin
    UserName := ParamStr(2) + '.' + ParamStr(3);
    UserIP := ParamStr(4);
  end else
  begin
  UserName := ParamStr(2);
  UserIP := ParamStr(3);
  end;
  if POS('LOCAL:', Username) > 0 then delete(username, 1,6); {Gamesrv puts LOCAL: in front of usernames}
  if WhatAreWeDoing = '/WRITE' then
  begin
    If UserName = TheSysopName then halt;       {Sysop doesn't want to be in stats}
    WriteItOut;
  end;
  if WhatAreWeDoing = '/READ' then
  begin
    ReadIt;
  end;
  if WhatAreWeDoing = '/?' then
  begin
    WriteLn;
    WriteLn('/WRITE - as the first commandline to write the user');
    WriteLn('/READ  - To launch as a Door / show the recent callers');
    WriteLn;
    Halt;
  end;
end.

